## qterm 0.7.2

=== CMakeLists.txt ===
project(qterm)
include(CTest)
include(FeatureSummary)
cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
set(QTERM_VERSION_MAJOR 0)
set(QTERM_VERSION_MINOR 7)
set(QTERM_VERSION_RELEASE 2)
set(QTERM_VERSION "${QTERM_VERSION_MAJOR}.${QTERM_VERSION_MINOR}.${QTERM_VERSION_RELEASE}" )
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(CMAKE_AUTOMOC ON)
IF(QT5)
    find_package(Qt5Core 5.3.0 REQUIRED)
    find_package(Qt5Gui 5.3.0 REQUIRED)
    find_package(Qt5Widgets 5.3.0 REQUIRED)
    find_package(Qt5Xml 5.3.0 REQUIRED)
    find_package(Qt5Network 5.3.0 REQUIRED)
    find_package(Qt5PrintSupport 5.3.0 REQUIRED)
    find_package(Qt5LinguistTools 5.3.0 REQUIRED)
    find_package(Qt5Help 5.3.0 REQUIRED)
    find_package(Qt5Script 5.3.0)
    find_package(Qt5ScriptTools 5.3.0)
    find_package(Qt5Multimedia 5.3.0)
    IF(NOT QT_BINARY_DIR)
        exec_program(${_qt5Core_install_prefix}/bin/qmake ARGS "-query QT_INSTALL_BINS"
            OUTPUT_VARIABLE QT_BINARY_DIR)
    ENDIF()
ELSE(QT5)
    find_package(Qt4 4.5.0 REQUIRED)
    find_package(KDE4)
ENDIF(QT5)

IF(WIN32 AND MSVC)
    ADD_DEFINITIONS (/D _CRT_SECURE_NO_WARNINGS)
ENDIF(WIN32 AND MSVC)

IF(APPLE)
   SET (PROGRAME QTerm)
   SET (MACOSX_BUNDLE_VERSION $QTERM_VERSION)
   SET (MACOSX_BUNDLE_ICON_FILE QTerm.icns)
ELSE(APPLE)
   SET (PROGRAME qterm)
ENDIF(APPLE)

include("package.cmake")
add_subdirectory(src)
add_subdirectory(icons)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
if (NOT TARGET uninstall)
    add_custom_target(uninstall
      "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif(NOT TARGET uninstall)
feature_summary(WHAT ALL)

=== icons/CMakeLists.txt ===
macro(qterm_install_icons _theme)

   file(GLOB _icons *.png)
   file(GLOB _svg *svgz)
   set(_icons ${_icons} ${_svg})
   foreach(_current_ICON ${_icons} )
      get_filename_component(_ctype ${_current_ICON} EXT)

      if (${_ctype} STREQUAL ".png")
         string(REGEX REPLACE "^.*/[a-zA-Z]+([0-9]+)\\-([a-z]+)\\-(.+\\.png)$" "\\1" _size "${_current_ICON}")
         string(REGEX REPLACE "^.*/[a-zA-Z]+([0-9]+)\\-([a-z]+)\\-(.+\\.png)$" "\\2" _group "${_current_ICON}")
         string(REGEX REPLACE "^.*/[a-zA-Z]+([0-9]+)\\-([a-z]+)\\-(.+\\.png)$" "\\3" _name "${_current_ICON}")
         set(_sizestring "${_size}x${_size}")
      endif (${_ctype} STREQUAL ".png")

      if (${_ctype} STREQUAL ".svgz")
         string(REGEX REPLACE "^.*/[a-zA-Z]+\\-([a-z]+)\\-(.+\\.svgz)$" "\\1" _group "${_current_ICON}")
         string(REGEX REPLACE "^.*/[a-zA-Z]+\\-([a-z]+)\\-(.+\\.svgz)$" "\\2" _name "${_current_ICON}")
         set(_sizestring "scalable")
      endif (${_ctype} STREQUAL ".svgz")

      set(_icon_GROUP "actions")

      if(${_group} STREQUAL "mime")
         set(_icon_GROUP  "mimetypes")
      endif(${_group} STREQUAL "mime")

      if(${_group} STREQUAL "filesys")
         set(_icon_GROUP  "filesystems")
      endif(${_group} STREQUAL "filesys")

      if(${_group} STREQUAL "device")
         set(_icon_GROUP  "devices")
      endif(${_group} STREQUAL "device")

      if(${_group} STREQUAL "app")
         set(_icon_GROUP  "apps")
      endif(${_group} STREQUAL "app")

      if(${_group} STREQUAL "action")
         set(_icon_GROUP  "actions")
      endif(${_group} STREQUAL "action")

      set(_ICON_INSTALL_DIR share/icons/${_theme}/${_sizestring}/${_icon_GROUP})

      install(FILES ${_current_ICON} DESTINATION ${_ICON_INSTALL_DIR} RENAME ${_name})

   endforeach (_current_ICON)
endmacro(qterm_install_icons)

if (NOT APPLE)
  qterm_install_icons(hicolor)
endif ()

=== src/CMakeLists.txt ===
set(optionalLibs)
set(optionalSources)
option(QTERM_ENABLE_SSH "Build SSH Support" ON)
option(QTERM_ENABLE_DBUS "Build DBus Support" ON)
option(QTERM_ENABLE_SCRIPT "Build Script Support" ON)
option(QTERM_ENABLE_QMEDIAPLAYER "Build QMediaPlayer Support" ON)
option(QTERM_ENABLE_PHONON "Build Phonon Support" ON)
option(QTERM_OLD_PHONON "Hack for Outdated Phonon Library" OFF)
option(QTERM_ENABLE_TEST "Build the tests")
option(QTERM_ENABLE_SCRIPT_DEBUGGER "Build ScriptDebugger Support")

include(CheckFunctionExists)
include(CheckLibraryExists)



check_function_exists("gethostbyname" CMAKE_HAVE_GETHOSTBYNAME)
if(NOT CMAKE_HAVE_GETHOSTBYNAME)
  check_library_exists("nsl" "gethostbyname" "" CMAKE_LIB_NSL_HAS_GETHOSTBYNAME)
  if(CMAKE_LIB_NSL_HAS_GETHOSTBYNAME)
    set(optionalLibs ${optionalLibs} -lnsl)
  else(CMAKE_LIB_NSL_HAS_GETHOSTBYNAME)
    check_library_exists("bsd" "gethostbyname" "" CMAKE_LIB_BSD_HAS_GETHOSTBYNAME)
    if(CMAKE_LIB_BSD_HAS_GETHOSTBYNAME)
      set(optionalLibs ${optionalLibs} -lbsd)
    endif(CMAKE_LIB_BSD_HAS_GETHOSTBYNAME)
  endif(CMAKE_LIB_NSL_HAS_GETHOSTBYNAME)
endif(NOT CMAKE_HAVE_GETHOSTBYNAME)

if(QTERM_ENABLE_SSH)
   find_package(OpenSSLCrypto)
   if(OPENSSLCRYPTO_FOUND)
      message(STATUS "OpenSSL found, enable SSH support")
      add_definitions(-DSSH_ENABLED)
      include_directories(${OPENSSLCRYPTO_INCLUDE_DIR})
      get_filename_component(OPENSSLCRYPTO_ROOT_DIR ${OPENSSLCRYPTO_INCLUDE_DIR} PATH)
      set(optionalLibs ${optionalLibs} ${OPENSSLCRYPTO_LIBRARIES})
      set(optionalSources ${optionalSources}
      ssh/libcrypto-compat.c
      ssh/key.cpp
      ssh/auth.cpp
      ssh/channel.cpp
      ssh/crc32.cpp
      ssh/kex.cpp
      ssh/packet.cpp
      ssh/socket.cpp
      ssh/transport.cpp)
   endif(OPENSSLCRYPTO_FOUND)
endif(QTERM_ENABLE_SSH)
if(QTERM_ENABLE_DBUS)
   if(QT_QTDBUS_FOUND)
      message(STATUS "QtDBus module found, enable DBus support")
      add_definitions(-DDBUS_ENABLED)
      include_directories(${QT_QTDBUS_INCLUDE_DIR})
      set(optionalLibs ${optionalLibs} ${QT_QTDBUS_LIBRARY})
      set(optionalSources ${optionalSources}
      imageconverter.cpp
      dbus.cpp)
      find_file(KWALLET_XML org.kde.KWallet.xml ${KDE4_DBUS_INTERFACES_DIR} ${DBUS_INTERFACES_INSTALL_DIR})
      if(KWALLET_XML)
         message(STATUS "KWallet found, enable KWallet support")
         add_definitions(-DKWALLET_ENABLED)
         qt4_add_dbus_interface(optionalSources ${KWALLET_XML} kwallet_interface )
         set(optionalSources ${optionalSources} wallet.cpp)
      endif(KWALLET_XML)
   endif(QT_QTDBUS_FOUND)
endif(QTERM_ENABLE_DBUS)
if(QTERM_ENABLE_SCRIPT)
    if(QT5)
        if(Qt5Script_FOUND)
            message(STATUS "QtScript module found, enable Script support")
            add_definitions(-DSCRIPT_ENABLED)
            include_directories(${Qt5Script_INCLUDE_DIRS})
            set(optionalLibs ${optionalLibs} ${Qt5Script_LIBRARIES})
            set(optionalSources ${optionalSources} scripthelper.cpp)
            if(QTERM_ENABLE_SCRIPT_DEBUGGER)
                if(Qt5ScriptTools_FOUND)
                   message(STATUS "QtScriptTools module found, enable Debugger support")
                   add_definitions(-DSCRIPTTOOLS_ENABLED)
                   include_directories(${Qt5ScriptTools_INCLUDE_DIRS})
                   set(optionalLibs ${optionalLibs} ${Qt5ScriptTools_LIBRARIES})
                else(Qt5ScriptTools_FOUND)
                   message(STATUS "QtScriptTools module not found")
                endif(Qt5ScriptTools_FOUND)
            endif(QTERM_ENABLE_SCRIPT_DEBUGGER)
        endif(Qt5Script_FOUND)
    else(QT5)
        if(QT_QTSCRIPT_FOUND)
            message(STATUS "QtScript module found, enable Script support")
            find_package(QtScriptQtBindings)
            add_definitions(-DSCRIPT_ENABLED)
            include_directories(${QT_QTSCRIPT_INCLUDE_DIR})
            set(optionalLibs ${optionalLibs} ${QT_QTSCRIPT_LIBRARY})
            set(optionalSources ${optionalSources} scripthelper.cpp)
            if(QTERM_ENABLE_SCRIPT_DEBUGGER)
                if(QT_QTSCRIPTTOOLS_FOUND)
                   message(STATUS "QtScriptTools module found, enable Debugger support")
                   add_definitions(-DSCRIPTTOOLS_ENABLED)
                   include_directories(${QT_QTSCRIPTTOOLS_INCLUDE_DIR})
                   set(optionalLibs ${optionalLibs} ${QT_QTSCRIPTTOOLS_LIBRARY})
                else(QT_QTSCRIPTTOOLS_FOUND)
                   message(STATUS "QtScriptTools module not found")
                endif(QT_QTSCRIPTTOOLS_FOUND)
            endif(QTERM_ENABLE_SCRIPT_DEBUGGER)
        endif(QT_QTSCRIPT_FOUND)
    endif(QT5)
endif(QTERM_ENABLE_SCRIPT)
if(QTERM_ENABLE_QMEDIAPLAYER)
   if(Qt5Multimedia_FOUND)
      message(STATUS "Qt Multimedia module found, enable QMediaPlayer support")
      add_definitions(-DQMEDIAPLAYER_ENABLED)
      include_directories(${Qt5Multimedia_INCLUDE_DIRS})
      set(optionalLibs ${optionalLibs} ${Qt5Multimedia_LIBRARIES})
   endif(Qt5Multimedia_FOUND)
endif(QTERM_ENABLE_QMEDIAPLAYER)
if(QTERM_ENABLE_PHONON)
   if(QT_PHONON_FOUND)
      message(STATUS "Qt Phonon module found, enable Phonon support")
      add_definitions(-DPHONON_ENABLED)
      include_directories(${QT_PHONON_INCLUDE_DIR})
      set(optionalLibs ${optionalLibs} ${QT_PHONON_LIBRARY})
      if(QTERM_OLD_PHONON OR QT_VERSION_MINOR LESS 5)
         add_definitions(-DOLD_PHONON)
      endif(QTERM_OLD_PHONON OR QT_VERSION_MINOR LESS 5)
   else(QT_PHONON_FOUND)
      # Looking for KDE4, it is quite impossible that some system can have
      # Phonon without KDE4
      if(PHONON_FOUND)
         message(STATUS "KDE Phonon module found, enable Phonon support")
         add_definitions(-DPHONON_ENABLED)
         include_directories(${KDE4_INCLUDES})
         set(optionalLibs ${optionalLibs} ${KDE4_PHONON_LIBRARY})
      endif(PHONON_FOUND)
   endif(QT_PHONON_FOUND)
endif(QTERM_ENABLE_PHONON)
set(qterm_SRCS
   ui_aboutdialog.h
   ui_addrdialog.h
   ui_articledialog.h
   ui_imageviewer.h
   ui_keydialog.h
   ui_mainframe.h
   ui_msgdialog.h
   ui_prefdialog.h
   ui_quickdialog.h
   ui_schemedialog.h
   ui_soundconf.h
   ui_sshlogin.h
   ui_shortcutsdialog.h
   ui_toolbardialog.h
   ui_zmodemdialog.h
   ui_closedialog.h
   ui_pallete.h
   aboutdialog.cpp
   addrdialog.cpp
   articledialog.cpp
   assistantclient.cpp
   imageviewer.cpp
   imagelistviewer.cpp
   keydialog.cpp
   main.cpp
   msgdialog.cpp
   osdmessage.cpp
   overlayWidget.cpp
   popupMessage.cpp
   popwidget.cpp
   prefdialog.cpp
   progressBar.cpp
   qtermbbs.cpp
   qtermbuffer.cpp
   qtermcanvas.cpp
   qtermconfig.cpp
   qtermconvert.cpp
   qtermdecode.cpp
   qtermframe.cpp
   qtermhttp.cpp
   qtermiplocation.cpp
   qtermparam.cpp
   qtermscreen.cpp
   qtermsocket.cpp
   qtermsound.cpp
   qtermtelnet.cpp
   qtermtextline.cpp
   qtermtoolbutton.cpp
   qtermwindow.cpp
   qtermwindowbase.cpp
   qtermzmodem.cpp
   qtermglobal.cpp
   quickdialog.cpp
   schemedialog.cpp
   shortcutsdialog.cpp
   statusBar.cpp
   toolbardialog.cpp
   zmodemdialog.cpp
   hostinfo.cpp
   termstring.cpp
   keyboardtranslator.cpp
   closedialog.cpp
   uaocodec.cpp
   dommodel.cpp
   pallete.cpp
   chartable.cpp
   charpane.cpp
   blur.cpp
   ${optionalSources})
set(qterm_UIS
   ui/aboutdialog.ui
   ui/addrdialog.ui
   ui/articledialog.ui
   ui/closedialog.ui
   ui/imageviewer.ui
   ui/keydialog.ui
   ui/mainframe.ui
   ui/msgdialog.ui
   ui/prefdialog.ui
   ui/quickdialog.ui
   ui/schemedialog.ui
   ui/shortcutsdialog.ui
   ui/soundconf.ui
   ui/sshlogin.ui
   ui/toolbardialog.ui
   ui/zmodemdialog.ui
   ui/pallete.ui)
set(qterm_MISC
   address.xml
   credits
   qterm.cfg)
set(qterm_RCCS
    qterm.qrc)

file(COPY ${qterm_MISC} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

find_program(XDGOPEN NAME xdg-open DOC "Looking for xdg-open")
if (XDGOPEN_FOUND)
  set (HTTP xdg-open)
else (XDGOPEN_FOUND)
  set (HTTP)
endif (XDGOPEN_FOUND)

configure_file(${CMAKE_CURRENT_BINARY_DIR}/qterm.cfg ${CMAKE_CURRENT_BINARY_DIR}/qterm.cfg)

if(WIN32)
  if(MINGW)
    # resource compilation for mingw
    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/qterm_rc.o
                       COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
                                           -i${CMAKE_CURRENT_SOURCE_DIR}/qterm.rc
                                           -o ${CMAKE_CURRENT_BINARY_DIR}/qterm_rc.o)
    SET(qterm_SRCS ${qterm_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/qterm_rc.o)
  else(MINGW)
    SET(qterm_SRCS ${qterm_SRCS} qterm.rc)
  endif(MINGW)
  set(optionalLibs ${optionalLibs} ws2_32)
  cmake_policy(SET CMP0020 NEW) # automatically link to qtmain.lib
endif(WIN32)
if(QT5)
    qt5_add_resources(qterm_RCCS_SRCS ${qterm_RCCS})
    qt5_wrap_ui(qterm_UIS_H ${qterm_UIS})
else(QT5)
    qt4_add_resources(qterm_RCCS_SRCS ${qterm_RCCS})
    qt4_wrap_ui(qterm_UIS_H ${qterm_UIS})
endif(QT5)
add_definitions( -DHAVE_CONFIG_H )
if(QT5)
include_directories(
    ${Qt5Qt_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    )
else(QT5)
include_directories(
   ${QT_INCLUDE_DIR}
   ${QT_QTCORE_INCLUDE_DIR}
   ${QT_QTGUI_INCLUDE_DIR}
   ${QT_QTNETWORK_INCLUDE_DIR} )
endif(QT5)
if(UNIX AND NOT APPLE)
   find_package(X11)
   include_directories(${X11_INCLUDE_DIR})
   set(optionalLibs ${optionalLibs} ${X11_X11_LIB})
endif(UNIX AND NOT APPLE)
include_directories(
   ${CMAKE_SOURCE_DIR}
   ${CMAKE_BINARY_DIR}
   ${CMAKE_CURRENT_BINARY_DIR}
   ${CMAKE_CURRENT_SOURCE_DIR})
if(WIN32)
   add_executable(${PROGRAME} WIN32 ${qterm_SRCS} ${qterm_RCCS_SRCS})
elseif(APPLE)
   set(qterm_MISC  ${qterm_MISC} ${CMAKE_CURRENT_SOURCE_DIR}/../icons/QTerm.icns)
   set_source_files_properties(${qterm_MISC} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
   add_executable(${PROGRAME} MACOSX_BUNDLE ${qterm_SRCS} ${qterm_RCCS_SRCS} ${qterm_MISC} ) 
   add_custom_command( TARGET ${PROGRAME} PRE_BUILD
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/MacOS
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/Resources
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/Resources/po
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/Resources/doc
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/Resources/keyboard_profiles
   )
   add_custom_command( TARGET ${PROGRAME} POST_BUILD
     COMMAND cp ARGS ${CMAKE_CURRENT_BINARY_DIR}/po/*.qm ${PROGRAME}.app/Contents/Resources/po
     COMMAND cp ARGS ${CMAKE_CURRENT_BINARY_DIR}/doc/*.{qhc,qch} ${PROGRAME}.app/Contents/Resources/doc
     COMMAND cp ARGS ${CMAKE_CURRENT_BINARY_DIR}/keyboard_profiles/*.keytab ${PROGRAME}.app/Contents/Resources/keyboard_profiles
   )
else()
   add_executable(${PROGRAME} ${qterm_SRCS} ${qterm_RCCS_SRCS})
endif()
if(QT5)
target_link_libraries(${PROGRAME}
    ${Qt5Core_LIBRARIES}
    ${Qt5Gui_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Xml_LIBRARIES}
    ${Qt5PrintSupport_LIBRARIES}
    ${Qt5Network_LIBRARIES}
   ${optionalLibs})
else(QT5)
target_link_libraries(${PROGRAME}
   Qt4::QtCore
   Qt4::QtGui
   Qt4::QtNetwork
   Qt4::QtXml
   ${optionalLibs})
endif(QT5)
if(WIN32 AND MINGW)
   target_link_libraries(${PROGRAME} ${win32Libs})
endif(WIN32 AND MINGW)
if (APPLE)
  install(TARGETS ${PROGRAME} DESTINATION .)
  if(QT5)
    foreach(plugin ${Qt5Gui_PLUGINS})
      get_target_property(_loc ${plugin} LOCATION)
      get_filename_component(_plugindir ${_loc} PATH)
      get_filename_component(_pluginname ${_plugindir} NAME)
      install(CODE "
          file(COPY ${_loc} DESTINATION \${CMAKE_INSTALL_PREFIX}/${PROGRAME}.app/Contents/PlugIns/${_pluginname})
          " COMPONENT Runtime)
    endforeach()
    get_target_property(QT_LIBRARY_DIR Qt5::Core LOCATION)
    get_filename_component(QT_LIBRARY_DIR ${QT_LIBRARY_DIR} PATH)
    get_filename_component(QT_LIBRARY_DIR "${QT_LIBRARY_DIR}/.." ABSOLUTE)
  else(QT5)
    install(DIRECTORY ${QT_PLUGINS_DIR}/imageformats DESTINATION ${PROGRAME}.app/Contents/PlugIns)

=== src/doc/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/src/pic/qterm.png ${CMAKE_CURRENT_BINARY_DIR}/qterm.png COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/qterm.qhp.in  ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhp)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/index.html.in ${CMAKE_CURRENT_BINARY_DIR}/index.html)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Script.html ${CMAKE_CURRENT_BINARY_DIR}/Script.html COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/about.txt ${CMAKE_CURRENT_BINARY_DIR}/about.txt COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/doc.css ${CMAKE_CURRENT_BINARY_DIR}/doc.css COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/qterm.qhcp ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhcp COPYONLY)

if (QT5)
ADD_CUSTOM_COMMAND(
  OUTPUT qterm.qhc
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhcp
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhp
  COMMAND Qt5::qcollectiongenerator
  ARGS qterm.qhcp
      -o qterm.qhc
  COMMENT "Compiling Qt help collection project qterm.qhcp"
)
else(QT5)
ADD_CUSTOM_COMMAND(
  OUTPUT qterm.qhc
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhcp
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhp
  COMMAND ${QT_QCOLLECTIONGENERATOR_EXECUTABLE}
  ARGS qterm.qhcp
      -o qterm.qhc
  COMMENT "Compiling Qt help collection project qterm.qhcp"
)
endif(QT5)

ADD_CUSTOM_TARGET(help_target
  DEPENDS qterm.qhc)

if (NOT APPLE)
  INSTALL(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhc
    DESTINATION share/qterm/doc
  )
endif ()

=== src/scheme/CMakeLists.txt ===
file(GLOB schemeFiles "${CMAKE_CURRENT_SOURCE_DIR}/*.scheme")
file(COPY ${schemeFiles} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
if (NOT APPLE)
  install(FILES ${schemeFiles} DESTINATION share/qterm/scheme)
endif()

=== src/scripts/CMakeLists.txt ===
file(GLOB scriptFiles "${CMAKE_CURRENT_SOURCE_DIR}/*.js")
file(COPY ${scriptFiles} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
if (NOT APPLE)
  install(FILES ${scriptFiles} DESTINATION share/qterm/scripts)
  add_subdirectory(ui)
endif()

=== src/scripts/ui/CMakeLists.txt ===
file(GLOB scriptFiles "${CMAKE_CURRENT_SOURCE_DIR}/*.ui")
file(COPY ${scriptFiles} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
install(FILES ${scriptFiles} DESTINATION share/qterm/scripts/ui)

=== debian/changelog ===
qterm (1:0.7.2-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:52:23 +0000

qterm (1:0.7.2-1) unstable; urgency=medium

  * New upstream release.
    + Extend port number selection up to 65535. (Closes: #764889)
  * Remove broken icon symlink.
    (Closes: #851902, LP: #581199)
  * Bump Standards-Version to 4.1.0. (No changes needed)
  * Drop all patches, applied upstream.

 -- Boyuan Yang <073plan@gmail.com>  Sun, 24 Sep 2017 19:31:26 +0800

=== debian/control ===
Source: qterm
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Chinese Team <chinese-developers@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <073plan@gmail.com>,
Build-Depends:
 debhelper (>= 10~),
 cmake,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtscript5-dev,
 qtmultimedia5-dev,
 libssl-dev,
 libdbusmenu-qt5-dev,
 libphonon4qt5-dev,
 qt5keychain-dev,
 libkf5wallet-dev,
 libqt5sql5-sqlite,
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/git/chinese/qterm.git
Vcs-Git: https://anonscm.debian.org/git/chinese/qterm.git
Homepage: https://github.com/qterm/qterm

Package: qterm
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: BBS client for X Window System written in Qt
 QTerm is a BBS client for X Window System. It supports telnet, ssh1 and ssh2
 protocols. It also supports zmodem, URL detect, mouse action.
 .
 It also supports detecting location from ip address, but you need do some
 extra work, see README.Debian.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export QT_SELECT := 5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DQT5=YES

override_dh_installchangelogs:
	dh_installchangelogs -k RELEASE_NOTES

## qterm 0.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
 set(QTERM_VERSION_MAJOR 0)
 set(QTERM_VERSION_MINOR 7)
-set(QTERM_VERSION_RELEASE 2)
+set(QTERM_VERSION_RELEASE 3)
 set(QTERM_VERSION "${QTERM_VERSION_MAJOR}.${QTERM_VERSION_MINOR}.${QTERM_VERSION_RELEASE}" )
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

=== cmake/bindingstest/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

find_package( Qt4 REQUIRED )

add_definitions(${QT_DEFINITIONS})
include_directories (${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTSCRIPT_INCLUDE_DIR})

add_executable (bindingstest QtScriptBindingsTest.cpp)
target_link_libraries(bindingstest ${QT_LIBRARY} ${QT_QTCORE_LIBRARY} ${QT_QTSCRIPT_LIBRARY})

=== src/test/CMakeLists.txt ===
enable_testing()
add_subdirectory(config)
add_subdirectory(global)
add_subdirectory(hostinfo)
#add_subdirectory(ssh)

=== src/test/config/CMakeLists.txt ===
set(config_SRCS
   testconfig.cpp
   ../../qtermconfig.cpp)
qt4_automoc(${config_SRCS})

include_directories(
${QT_INCLUDE_DIR}
${QT_QTCORE_INCLUDE_DIR}
${QT_QTGUI_INCLUDE_DIR}
${QT_QTTEST_INCLUDE_DIR}
${CMAKE_SOURCE_DIR}
${CMAKE_BINARY_DIR}
${CMAKE_CURRENT_BINARY_DIR}
${CMAKE_CURRENT_SOURCE_DIR})

add_executable(testconfig ${config_SRCS})

target_link_libraries(testconfig
${QT_LIBRARIES}
${QT_QTCORE_LIBRARY}
${QT_QTGUI_LIBRARY}
${QT_QTTEST_LIBRARY}
)

add_test(config ${EXEC_DIR}/testconfig)

=== src/test/hostinfo/CMakeLists.txt ===
set(hostinfo_SRCS
   testhostinfo.cpp
   ../../hostinfo.cpp)
qt4_automoc(${hostinfo_SRCS})

include_directories(
${QT_INCLUDE_DIR}
${QT_QTCORE_INCLUDE_DIR}
${QT_QTGUI_INCLUDE_DIR}
${QT_QTNETWORK_INCLUDE_DIR}
${QT_QTTEST_INCLUDE_DIR}
${CMAKE_SOURCE_DIR}
${CMAKE_BINARY_DIR}
${CMAKE_CURRENT_BINARY_DIR}
${CMAKE_CURRENT_SOURCE_DIR})

add_executable(testhostinfo ${hostinfo_SRCS})

target_link_libraries(testhostinfo
${QT_LIBRARIES}
${QT_QTCORE_LIBRARY}
${QT_QTGUI_LIBRARY}
${QT_QTTEST_LIBRARY}
)

add_test(hostinfo ${EXEC_DIR}/testhostinfo)

=== debian/changelog ===
qterm (1:0.7.3-2) unstable; urgency=medium

  * debian/control:
    + Bump Standards-Version to 4.2.1 (no changes needed).
    + Update my uploader email address and use the @debian.org one.

 -- Boyuan Yang <byang@debian.org>  Fri, 31 Aug 2018 16:55:23 -0400

qterm (1:0.7.3-1) unstable; urgency=medium

  * New upstream release.
    + Fix FTBFS against Qt 5.11.
  * debian/control: Bump Standards-Version to 4.2.0 (no changes needed).
  * debian/copyright: Refresh copyright date.
  * debian/patches: Drop all backported patches.
  * debian/copyright: Remove trailing empty line.

 -- Boyuan Yang <073plan@gmail.com>  Sat, 04 Aug 2018 22:21:00 +0800

qterm (1:0.7.2-2) unstable; urgency=medium

  * Backport all changes from trunk.
  * Bump Standards-Version to 4.1.4. (No changes needed)
  * d/control: Use Salsa platform for Vcs fields.
  * d/control: Bump debhelper compat to v11.
  * d/rules: Use "dh-missing --fail-missing".
  * Apply "wrap-and-sort -abst".

 -- Boyuan Yang <073plan@gmail.com>  Sun, 08 Apr 2018 23:58:47 +0800

=== debian/control ===
Source: qterm
Section: x11
Priority: optional
Maintainer: Debian Chinese Team <chinese-developers@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper (>= 11~),
 libdbusmenu-qt5-dev,
 libkf5wallet-dev,
 libphonon4qt5-dev,
 libqt5sql5-sqlite,
 libssl-dev,
 qt5keychain-dev,
 qtbase5-dev,
 qtmultimedia5-dev,
 qtscript5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/chinese-team/qterm
Vcs-Git: https://salsa.debian.org/chinese-team/qterm.git
Homepage: https://github.com/qterm/qterm

Package: qterm
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: BBS client for X Window System written in Qt
 QTerm is a BBS client for X Window System. It supports telnet, ssh1 and ssh2
 protocols. It also supports zmodem, URL detect, mouse action.
 .
 It also supports detecting location from ip address, but you need do some
 extra work, see README.Debian.

## qterm 0.7.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
 set(QTERM_VERSION_MAJOR 0)
 set(QTERM_VERSION_MINOR 7)
-set(QTERM_VERSION_RELEASE 3)
+set(QTERM_VERSION_RELEASE 4)
 set(QTERM_VERSION "${QTERM_VERSION_MAJOR}.${QTERM_VERSION_MINOR}.${QTERM_VERSION_RELEASE}" )
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
@@ -36,8 +36,14 @@
 
 IF(APPLE)
    SET (PROGRAME QTerm)
-   SET (MACOSX_BUNDLE_VERSION $QTERM_VERSION)
+   SET (MACOSX_BUNDLE_BUNDLE_NAME ${PROGRAME})
+   SET (MACOSX_BUNDLE_GUI_IDENTIFIER "org.qterm")
+   SET (MACOSX_BUNDLE_INFO_STRING "${PROGRAME} ${QTERM_VERSION}")
+   SET (MACOSX_BUNDLE_BUNDLE_VERSION ${QTERM_VERSION})
+   SET (MACOSX_BUNDLE_LONG_VERSION_STRING ${QTERM_VERSION})
+   SET (MACOSX_BUNDLE_SHORT_VERSION_STRING "${QTERM_VERSION_MAJOR}.${QTERM_VERSION_MINOR}")
    SET (MACOSX_BUNDLE_ICON_FILE QTerm.icns)
+   SET (MACOSX_BUNDLE_COPYRIGHT "The QTerm Project")
 ELSE(APPLE)
    SET (PROGRAME qterm)
 ENDIF(APPLE)

=== src/po/CMakeLists.txt ===
file(GLOB TRANSLATIONS_FILES *.ts)
if(QT5)
    qt5_add_translation(QM_FILES ${TRANSLATIONS_FILES})
else(QT5)
    qt4_add_translation(QM_FILES ${TRANSLATIONS_FILES})
endif(QT5)
add_custom_target(translations_target DEPENDS ${QM_FILES})
if (NOT APPLE)
  install(FILES ${QM_FILES} DESTINATION share/qterm/po)
endif()

=== src/test/ssh/CMakeLists.txt ===
set(ssh_SRCS
   ../../ssh/auth.cpp
   ../../ssh/channel.cpp
   ../../ssh/crc32.cpp
   ../../ssh/kex.cpp
   ../../ssh/packet.cpp
   ../../ssh/socket.cpp
   ../../ssh/transport.cpp
   ../../qtermsocket.cpp
   ../../hostinfo.cpp
   testssh.cpp)
qt4_automoc(${ssh_SRCS})

include_directories(
${QT_INCLUDE_DIR}
${QT_QTCORE_INCLUDE_DIR}
${QT_QTGUI_INCLUDE_DIR}
${QT_QTNETWORK_INCLUDE_DIR}
${QT_QTTEST_INCLUDE_DIR}
${CMAKE_SOURCE_DIR}
${CMAKE_BINARY_DIR}
${CMAKE_CURRENT_BINARY_DIR}
${CMAKE_CURRENT_SOURCE_DIR})

add_executable(testssh ${ssh_SRCS})

target_link_libraries(testssh
${QT_LIBRARIES}
${QT_QTCORE_LIBRARY}
${QT_QTGUI_LIBRARY}
${QT_QTNETWORK_LIBRARY}
${QT_QTTEST_LIBRARY}
${OPENSSL_CRYPTO_LIBRARIES}
)

add_test(ssh ${EXEC_DIR}/testssh)

=== debian/changelog ===
qterm (1:0.7.4-2build1) jammy; urgency=medium

  * No-change rebuild against libssl3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 09 Dec 2021 00:16:08 +0000

qterm (1:0.7.4-2) unstable; urgency=medium

  [ 肖盛文 ]
  * remove the automatically copied lines that are unrelated to the patch
  * delete outdated README.Debian
  * d/control:
      - delete outdated package Description about "detecting location from ip"
  * d/docs:
      - fix lintian repeated-path-segment
  * update qterm man manual
  * update debian/patches/qterm.desktop.patch, add Applied-Upstream
  * update debian/patches/spelling-error-in-binary.patch, add Applied-Upstream

 -- xiao sheng wen <atzlinux@sina.com>  Wed, 23 Sep 2020 17:26:42 +0800

qterm (1:0.7.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ 肖盛文 ]
  * New upstream version 0.7.4
  * add Uploaders: xiao sheng wen <atzlinux@sina.com>
  * Bump debhelper-compat (= 13)
  * Bump Standards-Version: 4.5.0
  * add Rules-Requires-Root: no
  * fix lintian: desktop-entry-lacks-keywords-entry
  * fix lintian: spelling-error-in-binary
  * add patches/series
  * fix lintian: debian-rules-uses-as-needed-linker-flag
  * d/copyright: add Upstream-Contact: Xiaoqiang Wang <xiaoqiangwang@gmail.com>
  * d/rules:
      - delete override_dh_missing
      - delete export DEB_LDFLAGS_MAINT_APPEND = -W

 -- xiao sheng wen <atzlinux@sina.com>  Tue, 12 May 2020 16:43:47 +0800

=== debian/control ===
Source: qterm
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Chinese Team <chinese-developers@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 xiao sheng wen <atzlinux@sina.com>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libdbusmenu-qt5-dev,
 libkf5wallet-dev,
 libphonon4qt5-dev,
 libqt5sql5-sqlite,
 libssl-dev,
 qt5keychain-dev,
 qtbase5-dev,
 qtmultimedia5-dev,
 qtscript5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/chinese-team/qterm
Vcs-Git: https://salsa.debian.org/chinese-team/qterm.git
Homepage: https://github.com/qterm/qterm

Package: qterm
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: BBS client for X Window System written in Qt
 QTerm is a BBS client for X Window System. It supports telnet, ssh1 and ssh2
 protocols. It also supports zmodem, URL detect, mouse action.

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,6 @@
 
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 export QT_SELECT := 5
 
 %:

## qterm 0.8.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11 FATAL_ERROR)
set(QTERM_VERSION_MAJOR 0)
set(QTERM_VERSION_MINOR 8)
set(QTERM_VERSION_RELEASE 2)
set(QTERM_VERSION "${QTERM_VERSION_MAJOR}.${QTERM_VERSION_MINOR}.${QTERM_VERSION_RELEASE}" )
project(qterm VERSION ${QTERM_VERSION} LANGUAGES CXX)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CTest)
include(FeatureSummary)

set(CMAKE_AUTOMOC ON)
find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}
    COMPONENTS Gui Widgets Xml Network PrintSupport LinguistTools Help
    OPTIONAL_COMPONENTS Script ScriptTools Multimedia
    QUIET)

IF (${QT_VERSION_MAJOR} VERSION_EQUAL 6)
    find_package(Qt6 COMPONENTS Tools Core5Compat REQUIRED)
ENDIF()

set(CMAKE_AUTOUIC TRUE)
set(CMAKE_AUTOUIC_SEARCH_PATHS  ${CMAKE_CURRENT_SOURCE_DIR}/src/ui)

include(ECMQueryQt)
IF(NOT QT_BINARY_DIR)
    ecm_query_qt(QT_BINARY_DIR QT_INSTALL_BINS)
ENDIF()

IF(NOT QT_LIBRARY_DIR)
    ecm_query_qt(QT_LIBRARY_DIR QT_INSTALL_LIBS)
ENDIF()

IF(NOT QT_PLUGINS_DIR)
    ecm_query_qt(QT_PLUGINS_DIR QT_INSTALL_PLUGINS)
ENDIF()

IF(WIN32 AND MSVC)
    ADD_DEFINITIONS (/D _CRT_SECURE_NO_WARNINGS)
ENDIF(WIN32 AND MSVC)

IF(APPLE)
   SET (PROGRAME QTerm)
   SET (MACOSX_BUNDLE_BUNDLE_NAME ${PROGRAME})
   SET (MACOSX_BUNDLE_GUI_IDENTIFIER "org.qterm")
   SET (MACOSX_BUNDLE_INFO_STRING "${PROGRAME} ${QTERM_VERSION}")
   SET (MACOSX_BUNDLE_BUNDLE_VERSION ${QTERM_VERSION})
   SET (MACOSX_BUNDLE_LONG_VERSION_STRING ${QTERM_VERSION})
   SET (MACOSX_BUNDLE_SHORT_VERSION_STRING "${QTERM_VERSION_MAJOR}.${QTERM_VERSION_MINOR}")
   SET (MACOSX_BUNDLE_ICON_FILE QTerm.icns)
   SET (MACOSX_BUNDLE_COPYRIGHT "The QTerm Project")
ELSE(APPLE)
   SET (PROGRAME qterm)
ENDIF(APPLE)

include("package.cmake")
add_subdirectory(src)
add_subdirectory(icons)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
if (NOT TARGET uninstall)
    add_custom_target(uninstall
      "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif(NOT TARGET uninstall)
feature_summary(WHAT ALL)

=== src/CMakeLists.txt ===
set(optionalLibs)
set(optionalSources)
option(QTERM_ENABLE_SSH "Build SSH Support" ON)
option(QTERM_ENABLE_DBUS "Build DBus Support" ON)
option(QTERM_ENABLE_SCRIPT "Build Script Support" ON)
option(QTERM_ENABLE_QMEDIAPLAYER "Build QMediaPlayer Support" ON)
option(QTERM_ENABLE_PHONON "Build Phonon Support" ON)
option(QTERM_OLD_PHONON "Hack for Outdated Phonon Library" OFF)
option(QTERM_ENABLE_TEST "Build the tests")
option(QTERM_ENABLE_SCRIPT_DEBUGGER "Build ScriptDebugger Support")

include(CheckFunctionExists)
include(CheckLibraryExists)

macro (_install_plugins)
   set(options "")
   set(oneValueArgs "DIRECTORY")
   set(multiValueArgs "MODULES")
   cmake_parse_arguments(ARG "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

   set(plugin_files)
   foreach(MODULE ${ARG_MODULES})
      if (QT_VERSION_MAJOR VERSION_LESS 6)
         foreach(plugin ${Qt${QT_VERSION_MAJOR}${MODULE}_PLUGINS})
             get_target_property(_loc ${plugin} LOCATION)
             list(APPEND plugin_files ${_loc})
         endforeach()
      else ()
         get_target_property(_plugins Qt${QT_VERSION_MAJOR}::${MODULE} QT_PLUGINS)
         if (_plugins)
            foreach (_plugin ${_plugins})
               get_target_property(_loc Qt${QT_VERSION_MAJOR}::${_plugin} LOCATION)
               list(APPEND plugin_files ${_loc})
            endforeach ()
         # CMake targets for plugins missing in Qt < 6.4
         # https://bugreports.qt.io/browse/QTBUG-94066
         else ()
            get_target_property(_plugin_types Qt${QT_VERSION_MAJOR}::${MODULE} MODULE_PLUGIN_TYPES)
            foreach (_plugin_type ${_plugin_types})
               file(GLOB _files
                   LIST_DIRECTORIES false
                   ${QT_PLUGINS_DIR}/${_plugin_type}/*)
               list(APPEND plugin_files ${_files})
            endforeach()
         endif()
      endif()
   endforeach()

   foreach(_plugin_file ${plugin_files})
      get_filename_component(_plugindir ${_plugin_file} PATH)
      get_filename_component(_pluginname ${_plugindir} NAME)
      install(CODE "
         file(COPY ${_plugin_file} DESTINATION \${CMAKE_INSTALL_PREFIX}/${ARG_DIRECTORY}/${_pluginname})
      " COMPONENT Runtime)
   endforeach()
endmacro()

check_function_exists("gethostbyname" CMAKE_HAVE_GETHOSTBYNAME)
if(NOT CMAKE_HAVE_GETHOSTBYNAME)
   check_library_exists("nsl" "gethostbyname" "" CMAKE_LIB_NSL_HAS_GETHOSTBYNAME)
   if(CMAKE_LIB_NSL_HAS_GETHOSTBYNAME)
      set(optionalLibs ${optionalLibs} -lnsl)
   else(CMAKE_LIB_NSL_HAS_GETHOSTBYNAME)
      check_library_exists("bsd" "gethostbyname" "" CMAKE_LIB_BSD_HAS_GETHOSTBYNAME)
      if(CMAKE_LIB_BSD_HAS_GETHOSTBYNAME)
         set(optionalLibs ${optionalLibs} -lbsd)
      endif(CMAKE_LIB_BSD_HAS_GETHOSTBYNAME)
   endif(CMAKE_LIB_NSL_HAS_GETHOSTBYNAME)
endif(NOT CMAKE_HAVE_GETHOSTBYNAME)

if(QTERM_ENABLE_SSH)
   find_package(OpenSSLCrypto)
   if(OPENSSLCRYPTO_FOUND)
      message(STATUS "OpenSSL found, enable SSH support")
      add_definitions(-DSSH_ENABLED)
      if(QTERM_ENABLE_SSH_DEBUG)
         add_definitions(-DSSH_DEBUG)
      endif()
      add_definitions(-DOPENSSL_API_COMPAT=10100)
      include_directories(${OPENSSLCRYPTO_INCLUDE_DIR})
      get_filename_component(OPENSSLCRYPTO_ROOT_DIR ${OPENSSLCRYPTO_INCLUDE_DIR} PATH)
      set(optionalLibs ${optionalLibs} ${OPENSSLCRYPTO_LIBRARIES})
      set(optionalSources ${optionalSources}
      ssh/libcrypto-compat.c
      ssh/key.cpp
      ssh/auth.cpp
      ssh/channel.cpp
      ssh/crc32.cpp
      ssh/kex.cpp
      ssh/packet.cpp
      ssh/socket.cpp
      ssh/transport.cpp)
   endif(OPENSSLCRYPTO_FOUND)
endif(QTERM_ENABLE_SSH)

if(QTERM_ENABLE_DBUS)
   if(QT_QTDBUS_FOUND)
      message(STATUS "QtDBus module found, enable DBus support")
      add_definitions(-DDBUS_ENABLED)
      include_directories(${QT_QTDBUS_INCLUDE_DIR})
      set(optionalLibs ${optionalLibs} ${QT_QTDBUS_LIBRARY})
      set(optionalSources ${optionalSources}
      imageconverter.cpp
      dbus.cpp)
      find_file(KWALLET_XML org.kde.KWallet.xml ${KDE4_DBUS_INTERFACES_DIR} ${DBUS_INTERFACES_INSTALL_DIR})
      if(KWALLET_XML)
         message(STATUS "KWallet found, enable KWallet support")
         add_definitions(-DKWALLET_ENABLED)
         qt4_add_dbus_interface(optionalSources ${KWALLET_XML} kwallet_interface )
         set(optionalSources ${optionalSources} wallet.cpp)
      endif(KWALLET_XML)
   endif(QT_QTDBUS_FOUND)
endif(QTERM_ENABLE_DBUS)

if(QTERM_ENABLE_SCRIPT)
   if(Qt5Script_FOUND)
      message(STATUS "QtScript module found, enable Script support")
      add_definitions(-DSCRIPT_ENABLED)
      include_directories(${Qt5Script_INCLUDE_DIRS})
      set(optionalLibs ${optionalLibs} ${Qt5Script_LIBRARIES})
      set(optionalSources ${optionalSources} scripthelper.cpp)
      if(QTERM_ENABLE_SCRIPT_DEBUGGER)
            if(Qt5ScriptTools_FOUND)
               message(STATUS "QtScriptTools module found, enable Debugger support")
               add_definitions(-DSCRIPTTOOLS_ENABLED)
               include_directories(${Qt5ScriptTools_INCLUDE_DIRS})
               set(optionalLibs ${optionalLibs} ${Qt5ScriptTools_LIBRARIES})
            else(Qt5ScriptTools_FOUND)
               message(STATUS "QtScriptTools module not found")
            endif(Qt5ScriptTools_FOUND)
      endif(QTERM_ENABLE_SCRIPT_DEBUGGER)
   endif(Qt5Script_FOUND)
endif(QTERM_ENABLE_SCRIPT)

if(QTERM_ENABLE_QMEDIAPLAYER)
   if(Qt5Multimedia_FOUND)
      message(STATUS "Qt Multimedia module found, enable QMediaPlayer support")
      add_definitions(-DQMEDIAPLAYER_ENABLED)
      include_directories(${Qt5Multimedia_INCLUDE_DIRS})
      set(optionalLibs ${optionalLibs} ${Qt5Multimedia_LIBRARIES})
   endif(Qt5Multimedia_FOUND)
endif(QTERM_ENABLE_QMEDIAPLAYER)

if(QTERM_ENABLE_PHONON)
   if(QT_PHONON_FOUND)
      message(STATUS "Qt Phonon module found, enable Phonon support")
      add_definitions(-DPHONON_ENABLED)
      include_directories(${QT_PHONON_INCLUDE_DIR})
      set(optionalLibs ${optionalLibs} ${QT_PHONON_LIBRARY})
      if(QTERM_OLD_PHONON OR QT_VERSION_MINOR LESS 5)
         add_definitions(-DOLD_PHONON)
      endif(QTERM_OLD_PHONON OR QT_VERSION_MINOR LESS 5)
   else(QT_PHONON_FOUND)
      # Looking for KDE4, it is quite impossible that some system can have
      # Phonon without KDE4
      if(PHONON_FOUND)
         message(STATUS "KDE Phonon module found, enable Phonon support")
         add_definitions(-DPHONON_ENABLED)
         include_directories(${KDE4_INCLUDES})
         set(optionalLibs ${optionalLibs} ${KDE4_PHONON_LIBRARY})
      endif(PHONON_FOUND)
   endif(QT_PHONON_FOUND)
endif(QTERM_ENABLE_PHONON)

set(qterm_SRCS
   aboutdialog.cpp
   addrdialog.cpp
   articledialog.cpp
   assistantclient.cpp
   imageviewer.cpp
   imagelistviewer.cpp
   keydialog.cpp
   main.cpp
   msgdialog.cpp
   osdmessage.cpp
   overlayWidget.cpp
   popupMessage.cpp
   popwidget.cpp
   prefdialog.cpp
   progressBar.cpp
   qtermbbs.cpp
   qtermbuffer.cpp
   qtermcanvas.cpp
   qtermconfig.cpp
   qtermconvert.cpp
   qtermdecode.cpp
   qtermframe.cpp
   qtermhttp.cpp
   qtermiplocation.cpp
   qtermparam.cpp
   qtermscreen.cpp
   qtermsocket.cpp
   qtermsound.cpp
   qtermtelnet.cpp
   qtermtextline.cpp
   qtermtoolbutton.cpp
   qtermwindow.cpp
   qtermwindowbase.cpp
   qtermzmodem.cpp
   qtermglobal.cpp
   quickdialog.cpp
   schemedialog.cpp
   shortcutsdialog.cpp
   statusBar.cpp
   toolbardialog.cpp
   zmodemdialog.cpp
   hostinfo.cpp
   termstring.cpp
   keyboardtranslator.cpp
   closedialog.cpp
   uaocodec.cpp
   dommodel.cpp
   pallete.cpp
   chartable.cpp
   charpane.cpp
   blur.cpp
   ${optionalSources})
set(qterm_UIS
   ui/aboutdialog.ui
   ui/addrdialog.ui
   ui/articledialog.ui
   ui/closedialog.ui
   ui/imageviewer.ui
   ui/keydialog.ui
   ui/mainframe.ui
   ui/msgdialog.ui
   ui/prefdialog.ui
   ui/quickdialog.ui
   ui/schemedialog.ui
   ui/shortcutsdialog.ui
   ui/soundconf.ui
   ui/sshlogin.ui
   ui/toolbardialog.ui
   ui/zmodemdialog.ui
   ui/pallete.ui)
set(qterm_UIS_H
   ui_aboutdialog.h
   ui_addrdialog.h
   ui_articledialog.h
   ui_imageviewer.h
   ui_keydialog.h
   ui_mainframe.h
   ui_msgdialog.h
   ui_prefdialog.h
   ui_quickdialog.h
   ui_schemedialog.h
   ui_soundconf.h
   ui_sshlogin.h
   ui_shortcutsdialog.h
   ui_toolbardialog.h
   ui_zmodemdialog.h
   ui_closedialog.h
   ui_pallete.h)
set(qterm_MISC
   address.xml
   credits
   qterm.cfg)
set(qterm_RCCS
    qterm.qrc)

file(COPY ${qterm_MISC} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

find_program(XDGOPEN NAME xdg-open DOC "Looking for xdg-open")
if (XDGOPEN_FOUND)
  set (HTTP xdg-open)
else (XDGOPEN_FOUND)
  set (HTTP)
endif (XDGOPEN_FOUND)

configure_file(${CMAKE_CURRENT_BINARY_DIR}/qterm.cfg ${CMAKE_CURRENT_BINARY_DIR}/qterm.cfg)

if(WIN32)
  if(MINGW)
    # resource compilation for mingw
    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/qterm_rc.o
                       COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
                                           -i${CMAKE_CURRENT_SOURCE_DIR}/qterm.rc
                                           -o ${CMAKE_CURRENT_BINARY_DIR}/qterm_rc.o)
    SET(qterm_SRCS ${qterm_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/qterm_rc.o)
  else(MINGW)
    SET(qterm_SRCS ${qterm_SRCS} qterm.rc)
  endif(MINGW)
  set(optionalLibs ${optionalLibs} ws2_32)
  cmake_policy(SET CMP0020 NEW) # automatically link to qtmain.lib
endif(WIN32)

if (QT_VERSION_MAJOR EQUAL 5)
  qt5_add_resources(qterm_RCCS_SRCS ${qterm_RCCS})
  qt5_wrap_ui(qterm_UIS_H ${qterm_UIS})
else ()
  qt_add_resources(qterm_RCCS_SRCS ${qterm_RCCS})
  # https://bugreports.qt.io/browse/QTBUG-93413
  if (QT_VERSION VERSION_LESS 6.7.1)
    qt_wrap_ui(qterm_UIS_H ${qterm_UIS} OPTIONS -c string)
  else ()
    qt_wrap_ui(qterm_UIS_H ${qterm_UIS})
  endif ()
endif ()

set(qterm_SRCS ${qterm_SRCS} ${qterm_RCCS} ${qterm_UIS})
add_compile_definitions( -DHAVE_CONFIG_H )
include_directories(
    ${Qt${QT_VERSION_MAJOR}Qt_INCLUDE_DIRS}
    ${Qt${QT_VERSION_MAJOR}Widgets_INCLUDE_DIRS}
    ${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}
    ${Qt${QT_VERSION_MAJOR}Network_INCLUDE_DIRS}
    )
    if(${QT_VERSION_MAJOR} VERSION_EQUAL 6)
        include_directories(${Qt${QT_VERSION_MAJOR}Core5Compat_INCLUDE_DIRS})
    endif()
if(UNIX AND NOT APPLE)
   find_package(X11)
   include_directories(${X11_INCLUDE_DIR})
   set(optionalLibs ${optionalLibs} ${X11_X11_LIB})
endif(UNIX AND NOT APPLE)
include_directories(
   ${CMAKE_SOURCE_DIR}
   ${CMAKE_BINARY_DIR}
   ${CMAKE_CURRENT_BINARY_DIR}
   ${CMAKE_CURRENT_SOURCE_DIR})
if(WIN32)
   add_executable(${PROGRAME} WIN32 ${qterm_SRCS} ${qterm_RCCS_SRCS})
elseif(APPLE)
   set(qterm_MISC  ${qterm_MISC} ${CMAKE_CURRENT_SOURCE_DIR}/../icons/QTerm.icns)
   set_source_files_properties(${qterm_MISC} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
   add_executable(${PROGRAME} MACOSX_BUNDLE ${qterm_SRCS} ${qterm_RCCS_SRCS} ${qterm_MISC} )
   add_custom_command( TARGET ${PROGRAME} PRE_BUILD
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/MacOS
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/Resources
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/Resources/po
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/Resources/doc
     COMMAND mkdir ARGS -p ${PROGRAME}.app/Contents/Resources/keyboard_profiles
   )
   add_custom_command( TARGET ${PROGRAME} POST_BUILD
     COMMAND cp ARGS ${CMAKE_CURRENT_BINARY_DIR}/po/*.qm ${PROGRAME}.app/Contents/Resources/po
   #  COMMAND cp ARGS ${CMAKE_CURRENT_BINARY_DIR}/doc/*.{qhc,qch} ${PROGRAME}.app/Contents/Resources/doc
     COMMAND cp ARGS ${CMAKE_CURRENT_BINARY_DIR}/keyboard_profiles/*.keytab ${PROGRAME}.app/Contents/Resources/keyboard_profiles
   )
else()
   add_executable(${PROGRAME} ${qterm_SRCS} ${qterm_RCCS_SRCS})
endif()
target_link_libraries(${PROGRAME}
    ${Qt${QT_VERSION_MAJOR}Core_LIBRARIES}
    ${Qt${QT_VERSION_MAJOR}Gui_LIBRARIES}
    ${Qt${QT_VERSION_MAJOR}Widgets_LIBRARIES}
    ${Qt${QT_VERSION_MAJOR}Xml_LIBRARIES}

=== src/doc/CMakeLists.txt ===
--- 
+++ 
@@ -6,27 +6,21 @@
 CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/doc.css ${CMAKE_CURRENT_BINARY_DIR}/doc.css COPYONLY)
 CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/qterm.qhcp ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhcp COPYONLY)
 
-if (QT5)
+if (QT_VERSION VERSION_LESS 6)
+  set (HELPGENERATOR qcollectiongenerator)
+else ()
+  set (HELPGENERATOR qhelpgenerator)
+endif ()
+
 ADD_CUSTOM_COMMAND(
   OUTPUT qterm.qhc
   DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhcp
   DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhp
-  COMMAND Qt5::qcollectiongenerator
+  COMMAND Qt${QT_VERSION_MAJOR}::${HELPGENERATOR}
   ARGS qterm.qhcp
       -o qterm.qhc
   COMMENT "Compiling Qt help collection project qterm.qhcp"
 )
-else(QT5)
-ADD_CUSTOM_COMMAND(
-  OUTPUT qterm.qhc
-  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhcp
-  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qterm.qhp
-  COMMAND ${QT_QCOLLECTIONGENERATOR_EXECUTABLE}
-  ARGS qterm.qhcp
-      -o qterm.qhc
-  COMMENT "Compiling Qt help collection project qterm.qhcp"
-)
-endif(QT5)
 
 ADD_CUSTOM_TARGET(help_target
   DEPENDS qterm.qhc)

=== src/keyboard_profiles/CMakeLists.txt ===
file(GLOB keyboardFiles "${CMAKE_CURRENT_SOURCE_DIR}/*.keytab")
file(COPY ${keyboardFiles} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
if (NOT APPLE)
  install(FILES ${keyboardFiles} DESTINATION share/qterm/keyboard_profiles)
endif ()

=== src/po/CMakeLists.txt ===
file(GLOB TRANSLATIONS_FILES *.ts)
if (QT_VERSION_MAJOR EQUAL 5)
  qt5_add_translation(QM_FILES ${TRANSLATIONS_FILES})
else ()
  qt_add_translation(QM_FILES ${TRANSLATIONS_FILES})
endif ()
add_custom_target(translations_target DEPENDS ${QM_FILES})
if (NOT APPLE)
  install(FILES ${QM_FILES} DESTINATION share/qterm/po)
endif()

=== debian/changelog ===
qterm (1:0.8.2-1) unstable; urgency=medium

  * New upstream version
  * Refresh patches
  * Standards-Version: 4.7.0 (routine-update)
  * d/copyright:
      - update year info to 2024
      - update to fix lrc check
      - delete unused License: LGPL-2.1 text

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 19 Sep 2024 15:53:59 +0800

qterm (1:0.7.4-3) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.6.2.
  * debian/control: Drop myself from the uploaders list.

 -- Boyuan Yang <byang@debian.org>  Fri, 15 Mar 2024 09:19:38 -0400

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,8 @@
 Source: qterm
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Chinese Team <chinese-developers@lists.alioth.debian.org>
+Maintainer: Debian Chinese Team <chinese-developers@lists.alioth.debian.org>
 Uploaders:
- Boyuan Yang <byang@debian.org>,
  xiao sheng wen <atzlinux@sina.com>,
 Build-Depends:
  cmake,
@@ -20,7 +18,7 @@
  qtscript5-dev,
  qttools5-dev,
  qttools5-dev-tools,
-Standards-Version: 4.5.0
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/chinese-team/qterm
 Vcs-Git: https://salsa.debian.org/chinese-team/qterm.git

=== debian/watch ===
# See uscan(1) for format
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%qterm-$1.tar.gz%" \
     https://github.com/qterm/qterm/tags \
     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
